<?php
/*
Plugin Name: ゆずまるのPLUGIN ひな形
Description: set_plugin_yuzu を XXXX_yuzu に置換して使う
Version: 2.40531
Author: yuzumaru
*/
/********************************************************/
function set_plugin_yuzu_ver()
/********************************************************/
{
	// ------------------------
	// [ version 表記 ]
	// ------------------------
	return "2.40531";
}
/********************************************************/
function set_plugin_yuzu_name()
/********************************************************/
{
	// ------------------------
	// [ Plugin名 ]
	// ------------------------
	return "ゆずまるのPLUGIN ひな形";
}
/********************************************************/
function set_plugin_yuzu_description()
/********************************************************/
{
	// ------------------------
	// [ Description ]
	// ------------------------
	return "set_plugin_yuzu を XXXX_yuzu に置換して使う";
}
/********************************************************/
function set_plugin_yuzu_echo($arrayTitle,$mess='')
/********************************************************/
{
	//
	//set_plugin_yuzu_echo('AAA',$AAA);	//Title + Single & Array
	//
	//set_plugin_yuzu_echo($AAA);		//Non Title : Single & Array
	//
	//set_plugin_yuzu_echo('AA='.$AAA);	// Single
	//
	if($arrayTitle!='' && $mess===''){
		$mess = $arrayTitle;
		$arrayTitle = '';
	}
	// 画面に表示
	if(is_array($mess)){
		if($arrayTitle!=''){
			echo '--- '.$arrayTitle.' ---<br />';
		}
		echo '<pre>';
		var_dump($mess);
		echo '</pre>';
	}else{
		if($arrayTitle!==''){
			if($arrayTitle[-1]!='='){
				echo $arrayTitle.'=';
			}else{
				echo $arrayTitle;
			}
		}
		echo $mess.'<br />';
	}
}
/********************************************************/
function set_plugin_yuzu_tracesub($mess,$p='a',$w='a')
/********************************************************/
{
	//
	// --- $mess is single value ---
	// set_plugin_yuzu_tracesub('---trace---','w');
	// set_plugin_yuzu_tracesub($mess);
	//
	// --- $mess is array ---
	// ※secnd para is array title.
	// set_plugin_yuzu_tracesub($mess,'---stack mess---','w');
	// set_plugin_yuzu_tracesub($mess,'---stack mess---');
	//
	// --- trace file name modify ---
	// set_plugin_yuzu_tracesub($mess,'f:xxxx','w');
	// set_plugin_yuzu_tracesub($mess,'f:xxxx');
	//
	//return
	//
	$subh = 'set_plugin_yuzu';
	
	$path = plugin_dir_path(__FILE__);		// 出力先 本プラグインフォルダー
	//$path = get_template_directory().'/';	// 出力先 現在使用中テーマ
	//$path = WP_CONTENT_DIR.'/';				// 出力先 WP-CONTENTS/
	//
	if(!is_array($mess) && is_array($p)){
		$work = $mess;
		$mess = $p;
		$p    = $work;
	}
	if(strtolower(substr($p,0,2))=='f:'){
		$file = $path.$subh.'_'.substr($p,2).'.cgi';
		$p = $w;
	
	}else{
		$file = $path.$subh.'_'.'log'.'.cgi';
	}
	
	$head = '';
	if($p!='a' && $p!='w'){
		$head = $p;
		$p    = $w;
	}
	$fp = fopen($file,$p);
	if($p=='w'&&$mess==''){
	}else{
		if(is_array($mess)){
			fwrite($fp, $head."\n");
			fwrite($fp, print_r($mess, true));
			fwrite($fp, "/"."$head\n");
		}else{
			if($head!=''){
				fwrite($fp, $head.'='.$mess."\n");
			}else{
				fwrite($fp, $mess."\n");
			}
		}
	}
	fclose($fp);
}
/********************************************************/
// 設定
/********************************************************/
// apply_filters ->  add_filter

//-------------------------------------------------------
// コンテンツ編集
//remove_filter('the_content','set_plugin_yuzu_content');
//add_filter(   'the_content','set_plugin_yuzu_content');
//-------------------------------------------------------
//
//-------------------------------------------------------
// WP設定画面に追加
add_action(   'admin_menu' ,'set_plugin_yuzu_control');
//-------------------------------------------------------
//
//-------------------------------------------------------
// ショートコード
//add_shortcode('set_plugin_yuzu'  , 'set_plugin_yuzu_Shortcode');
//-------------------------------------------------------
//
/********************************************************/
function set_plugin_yuzu_Shortcode($atts)
/********************************************************/
{
	// [shortCode year=xxxx month=xx ・・・]
	extract(shortcode_atts(array(
		'year'     => date('Y'),	// 開始年
		'month'    => date('m'),	// 開始月
		'count'    => "1",			// 繰り返し回数
		'eng'      => "",			// english : y
	), $atts));

//		：
//		：
//	$a0 = $year;
//	$a1 = $month;
//	$a2 = $count;
//	$a3 = $eng;
//		：
//		：

	return($replace_data);
}
/********************************************************/
function set_plugin_yuzu_content($content)	// コンテンツ編集
/********************************************************/
{
	
	return($content);
}
/********************************************************/
function set_plugin_yuzu_control()			// WP設定画面に追加
/********************************************************/
{
	add_options_page(
		set_plugin_yuzu_name()		,	// 1.設定画面での見出し
		set_plugin_yuzu_name()		,	// 2.設定->メニューでの名前
		'administrator'		,	// 3.アクセスレベル
		__FILE__			,	// 4.決まり文句
		'set_plugin_yuzu_entry'			// 5.設定の本体関数名
	);
}
/********************************************************/
function set_plugin_yuzu_entry()
/********************************************************/
{
	echo "<h2>".set_plugin_yuzu_name()." ver ".set_plugin_yuzu_ver().".</h2>";

	set_plugin_yuzu_tracesub('---','w');

	//----------------------------------------------------
	// 使用(メタ)
	// '&lt;' 等の特殊文字を '<' 通常文字に変換して使用する
	//----------------------------------------------------
	//$set_plugin_yuzu_title = set_plugin_yuzu_entryget('set_plugin_yuzu_title');
	
	//----------------------------------------------------
	// 保存(entry 管理)
	//----------------------------------------------------
	//$act_plugins = set_plugin_yuzu_MySQLpluginis();		// 有効なプラグイン
	if( isset($_POST['action']) ){
		$act_plugin = array();
		$x = $_POST['max'];
		for($n=0;$n<$x;$n++){
			$smbl = 'plugin_'.$n;
			if(!isset($_POST[$smbl])){$_POST[$smbl]='';}	// field が checkbox 等の場合
			else{
				$act_plugin[] = $_POST[$smbl];
			}
		}
		set_plugin_yuzu_put_active_plugin($act_plugin);
	}
	//----------------------------------------------------
	// 読込(entry 管理)
	//----------------------------------------------------
	// '<' 等の通常文字を '&lt;' 特殊文字に変換 (set_plugin_yuzu_default() の設定を忘れずに)
	//----------------------------------------------------
	//$set_plugin_yuzu_title = set_plugin_yuzu_entryget('set_plugin_yuzu_title','entry');
	
	//----------------------------------------------------
	// 表示準備
	//----------------------------------------------------
	$all_plugins = set_plugin_yuzu_get_plugin_list();		// プラグインリスト
	
	//----------------------------------------------------
	// 表示
	//----------------------------------------------------
?>
<table style="width:80%;">
<form method="post" action="">
	<tr>
		<td align="" style="font-weight:bold;font-size:120%;">
			<?php echo set_plugin_yuzu_description(); ?>
		</td>
	</tr>
	<tr>
		<td align="" style="border:3px double #ccc;padding:0.5rem;">
			<table>
				<tr>
					<th>PLUGINS</td>
				</tr>
<?php
	$n = 0;
	foreach($all_plugins as $v){
		$datas = explode('<>',$v);
		$pname = $datas[0];
		$ppath = $datas[1];
		$checked = $datas[2];
		$smbl = 'plugin_'.$n;
		$n++;
		echo <<<EOM
				<tr>
					<td>
						<input type="checkbox" name="$smbl" id="$smbl" value="$ppath" $checked>$pname
					</td>
				</tr>
EOM;
	}
?>
			</table>
			<input type="hidden" name="max" id="max" value="<?php echo $n; ?>">
		</td>
	</tr>

	<tr>
		<td colspan="2"align="center">
			<p style="text-align:right;">
				<input type="submit" class="button-primary" name="action" value="<?php _e('Save Changes') ?>" />
				<input type="hidden" name="action" value="update" />
			</p>
		</td>
	</tr>

</form>
</table>
<?php
}
/********************************************************/
function set_plugin_yuzu_put_active_plugin($plugins=array())
/********************************************************/
{
	global $table_prefix;
	global $wpdb;
	$db_name = DB_NAME;       //データベース名の取得
	$db_user = DB_USER;       //データベース接続ユーザーの取得
	$db_pass = DB_PASSWORD;   //データベース接続用パスワードの取得
	$db_host = DB_HOST;       //データベースホストの取得
	$db_pfix = $table_prefix; //データベースてテーブルプレフィックス
	
	$link = mysqli_connect($db_host, $db_user, $db_pass,$db_name);
	if (!$link) {
		return('');
	}
	// データ処理
	//
	// $plugins は、plugin path の入った配列
	// 
	//		"all-in-one-wp-migration-4g/all-in-one-wp-migration-4g.php";
	//		"classic-editor/classic-editor.php";
	//		"classic-widgets/classic-widgets.php";
	//		"dashboardmemo_yuzu/dashboardmemo_yuzu.php";
	//		"wp_migration_yuzu/wp_migration_yuzu.php";
	//		"wp_uninstall_yuzu/wp_uninstall_yuzu.php";
	//
	// 配列は基本 配列をシリアライズして保存
	//
	$value = serialize( $plugins );
	//
	// データベースへ書き込む
	//
	// +-----------+--------------+---------------+----------+
	// | option_id | option_name  | option_value  | autoload |
	// +-----------+--------------+---------------+----------+
	// | nnnnnnnnn | actve_plugin | a:1:{s:7:"…" | no       |
	// +-----------+--------------+---------------+----------+
	// | nnnnnnnnn | admin_mail   | xxxxx@xxx.com | no       |
	// +-----------+--------------+---------------+----------+
	//
	// 更新 UPDATE 書式
	// UPDATE table_name SET ｶﾗﾑ名='値' WHERE ｶﾗﾑ名='書き込むｶﾗﾑ名'
	//
	$sql = "UPDATE ";
	$sql.= $table_prefix."options ";
	$sql.= "SET ";
	$sql.= "option_value = '".$value."' ";
	$sql.= "WHERE ";
	$sql.= "option_name = 'active_plugins' ";
	$sql.= ";";
	
	$stat = mysqli_query($link, $sql);
	mysqli_close($link);
	
	return($stack);
}

/********************************************************/
function set_plugin_yuzu_get_active_plugin($cmd='active_plugins')
/********************************************************/
{
	global $table_prefix;
	global $wpdb;
	$db_name = DB_NAME;		//データベース名の取得
	$db_user = DB_USER;		//データベース接続ユーザーの取得
	$db_pass = DB_PASSWORD;	//データベース接続用パスワードの取得
	$db_host = DB_HOST;		//データベースホストの取得
	$db_pfix = $table_prefix;		//データベースホストの取得
	
	$link = mysqli_connect($db_host, $db_user, $db_pass,$db_name);
	if (!$link) {
		return('');
	}
	// 
	// 一部のプラグインを無効化するには、無効化したいプラグイン名(PATH付き)を
	// active plugins の n 番目かを検索。そのプラグインの行を消す。
	// ["option_value"]=>
	//	a:6:{
	//		i:0;s:57:"all-in-one-wp-migration-4g/all-in-one-wp-migration-4g.php";
	//		i:1;s:33:"classic-editor/classic-editor.php";
	//		i:2;s:35:"classic-widgets/classic-widgets.php";
	//		i:3;s:41:"dashboardmemo_yuzu/dashboardmemo_yuzu.php";
	//		i:4;s:39:"wp_migration_yuzu/wp_migration_yuzu.php";
	//		i:5;s:39:"wp_uninstall_yuzu/wp_uninstall_yuzu.php";
	//	}"
	//
	// 
	$stack = array();
	// データ処理
	if($cmd == 'active_plugins'){
		$sql = "SELECT ";
		$sql.= "* ";
		$sql.= "FROM ";
		$sql.= $db_pfix."options ";
		$sql.= "WHERE ";
		$sql.= "option_name = 'active_plugins'";
		$sql.= ";";
		if( $rows = mysqli_query($link, $sql) ){
			foreach($rows as $row){
				$value = maybe_unserialize( $row['option_value'] );
				if(is_array($value)){
					foreach($value as $val){
						$stack[] = $val;
					}
				}
			}
		}
	}
	mysqli_close($link);
	return($stack);
}
/********************************************************/
function set_plugin_yuzu_get_plugin_list()
/********************************************************/
{
	//
	// --- Wp Plugin 以外で使うとき ---
	//	require_once($_SERVER['DOCUMENT_ROOT']. '/wp-load.php');
	//	require_once($_SERVER['DOCUMENT_ROOT']. '/wp-includes/default-constants.php');
	//	include_once( ABSPATH . 'wp-admin/includes/plugin.php' );
	//---------------------------------
	//	$plugins の中身
	//	["set_plugin/set_plugin.php"]=> ← この部分が $pathになる。active-plugins に登録してある $path は、これにあたる
	//		array(15) {
	//			["Name"]=>
	//			string(31) "ゆずまるのPLUGIN ひな形"
	//			["PluginURI"]=>
	//			string(0) ""
	//			["Version"]=>
	//			string(7) "2.40531"
	//			["Description"]=>
	//			string(51) "set_plugin_yuzu を XXXX_yuzu に置換して使う"
	//			["Author"]=>
	//			string(8) "yuzumaru"
	//			["AuthorURI"]=>
	//			string(0) ""
	//			["TextDomain"]=>
	//			string(10) "set_plugin"
	//			["DomainPath"]=>
	//			string(0) ""
	//			["Network"]=>
	//			bool(false)
	//			["RequiresWP"]=>
	//			string(0) ""
	//			["RequiresPHP"]=>
	//			string(0) ""
	//			["UpdateURI"]=>
	//			string(0) ""
	//			["RequiresPlugins"]=>
	//			string(0) ""
	//			["Title"]=>
	//			string(31) "ゆずまるのPLUGIN ひな形"
	//			["AuthorName"]=>
	//			string(8) "yuzumaru"
	//			}
	//---------------------------------
	//	$plugin の中身
	//	array(15) {
	//		["Name"]			=>"ゆずまるのPLUGIN ひな形"
	//		["PluginURI"]		=>""
	//		["Version"]			=>"2.40531"
	//		["Description"]		=>"set_plugin_yuzu を XXXX_yuzu に置換して使う"
	//		["Author"]			=>"yuzumaru"
	//		["AuthorURI"]		=>""
	//		["TextDomain"]		=>"set_plugin"
	//		["DomainPath"]		=>""
	//		["Network"]			=>bool(false)
	//		["RequiresWP"]		=>""
	//		["RequiresPHP"]		=>""
	//		["UpdateURI"]		=>""
	//		["RequiresPlugins"]	=>""
	//		["Title"]			=>"ゆずまるのPLUGIN ひな形"
	//		["AuthorName"]		=>"yuzumaru"
	//	}
	//
	$active_plugins = set_plugin_yuzu_get_active_plugin();
	//
	$stack = array();
	$plugins = get_plugins();
	if (!empty($plugins)) {
		/**
		echo '<pre>';
		var_dump($plugins);
		echo '</pre>';
		**/
		$rows = '';
		foreach ($plugins as $path => $plugin){
			/**
			echo '<pre>';
			var_dump($plugin);
			echo '</pre>';
			**/
			// pulugin path は、アクティブか？
			if( in_array($path,$active_plugins) ){		// べた書き
			//if (is_plugin_active( $path )) {			// wordpress 内関数
				$stack[] = $plugin['Name'].'<>'.$path.'<>checked<>';
			}else{
				$stack[] = $plugin['Name'].'<>'.$path.'<><>';
			}
		}
	}
    return($stack);
}
/********************************************************/
function set_plugin_yuzu_entryget($name,$type='')
/********************************************************/
{
	$temp   = get_option($name);
	if($temp==''){ $temp = set_plugin_yuzu_default($name); }	//デフォルト設定
	if($type==''){
		return(wp_migration_yuzu_plantext( $temp ));	// &lt; → <
	}else{
		return(wp_migration_yuzu_metatext( $temp ));	// < → &lt;
	}
}
/********************************************************/
function set_plugin_yuzu_default($smbl)
/********************************************************/
{
//	if($smbl=='set_plugin_yuzu_title'){
//		return('ニュースとお知らせ');
//	}
	return('');
}
/********************************************************/
function set_plugin_yuzu_cutcr($str)
/********************************************************/
{
	$str = set_plugin_yuzu_cr($str,'#cr#');
	$str = str_replace("#cr#",''    , $str);
	return($str);
}
/********************************************************/
function set_plugin_yuzu_cr($str,$cr)
/********************************************************/
{
	//
	// 改行の統一
	//
	$str = str_replace("\r\n", "#cr#" , $str);
	$str = str_replace("\n"  , "#cr#" , $str);
	$str = str_replace("\r"  , "#cr#" , $str);
	$str = str_replace("#cr#",  $cr   , $str);
	return $str;
}
/********************************************************/
function set_plugin_yuzu_metatext($val)
/********************************************************/
{
	$val = str_replace('<','&lt;'   ,$val);
	$val = str_replace('>','&gt;'   ,$val);
	$val = str_replace('\"','&quot;',$val);
	$val = str_replace("\'",'&#39;' ,$val);
	return $val;
}
/********************************************************/
function set_plugin_yuzu_plantext($val)
/********************************************************/
{
	$val = str_replace('&lt;'   , '<'  ,  $val);
	$val = str_replace('&gt;'   , '>'  ,  $val);
	$val = str_replace('&quot;' , '\"' ,  $val);
	$val = str_replace('&#39;'  , "\'" ,  $val);
	$val = str_replace('\"','"',$val);
	$val = str_replace("\'","'",$val);
	// &&?; で ? の表示
	$s=0;
	$p=strpos($val,'&&',$s);
	while( $p!==false ){
		$s = $p+2;
		if(substr($val,$p+3,1)==';'){
			$f = substr($val, 0,$p).substr($val,$p+2,1);
			$s = strlen($f);
			$b = substr($val,$p+4);
			$val = $f.$b;
		}
		$p=strpos($val,'&&',$s);
	}
	return $val;
}
?>